package compbio.stat.servlet;

import java.io.IOException;
import java.sql.SQLException;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Map;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import compbio.stat.servlet.util.StatCollection;
import compbio.stat.servlet.util.Totals;

public class DisplayStat extends HttpServlet {

	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		String month = req.getParameter("month");
		System.out.println("? " + month);
		DateFormat df = SimpleDateFormat.getInstance();

		try {
			Date fromDate = df.parse(month);
			Map<Date, StatCollection> statsMap = StatCollection
					.getStats(fromDate);
			assert statsMap.size() == 1;
			StatCollection stats = statsMap.values().iterator().next();
			req.setAttribute("stat", stats.getAllStat());
			req.setAttribute("statTotal", Totals.sumStats(stats.getAllStat()));
			req.setAttribute("statTotalCluster",
					Totals.sumStats(stats.getClusterStat()));
			req.setAttribute("statTotalLocal",
					Totals.sumStats(stats.getLocalStat()));

			req.setAttribute("startDate", fromDate.getTime());
			Calendar c = GregorianCalendar.getInstance();
			c.setTime(fromDate);
			c.add(Calendar.MONTH, 1);
			req.setAttribute("stopDate", c.getTime());

			RequestDispatcher dispatcher = req
					.getRequestDispatcher("statpages/Statistics.jsp");
			dispatcher.forward(req, resp);

		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
}
